<template>
    <div v-if="temporaryInput !== null" class="field is-horizontal is-marginless has-xsmall-vpadding">
        <div class="field-label is-normal">
            <label class="label">{{ linkedInput.label }}:</label>
        </div>
        <div class="field-body">
            <div v-bind:class="{ 'has-addons' : isUnitNeeded() }" class="field">
                <div v-bind:class="{ 'is-expanded' : isUnitNeeded() }" class="control">
                    <input
                        v-if="linkedInput.kind.type === 'string'"
                        v-model="linkedInput.value"
                        class="input is-rounded"
                    />
                    <textarea 
                        v-else-if="linkedInput.kind.type === 'longString'"
                        v-model="linkedInput.value"
                        class="input textarea has-fixed-size"
                    >
                    </textarea>
                    <input
                        v-else-if="linkedInput.kind.name === 'temperature'"
                        v-model="linkedInput.value"
                        class="input is-rounded"
                        type="number"
                    />
                    <input
                        v-else
                        v-bind:value="temporaryInput"
                        v-on:input="validateInput($event.target.value)"
                        v-bind:class="{ 'is-danger' : temporaryInput !== linkedInput.value }"
                        class="input is-rounded"
                    />
                </div>
                <p v-if="isUnitNeeded()" class="control">
                    <span class="select is-rounded">
                        <select>
                            <option>°C</option>
                            <option>°F</option>
                        </select>
                    </span>
                </p>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
    import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
    import { State } from 'vuex-class';

    import { Checker } from '@/ts/checker';
    import { Folder } from '@/ts/folder';
    import { Mapview } from '@/ts/mapview';

    @Component
    export default class CustomInput extends Vue {
        @State('map') private map!: Mapview;

        @Prop()
        private linkedInput!: Input;
        @Prop()
        private function!: () => void;

        private temporaryInput: string | number | null = null;

        @Watch('linkedInput')
        private onLinkedInputChange() {
            this.temporaryInput = this.linkedInput.value;
        }

        private mounted(): void {
            this.temporaryInput = this.linkedInput.value;
        }

        private isUnitNeeded(): boolean {
            return this.linkedInput.kind.name === 'temperature';
        }

        private validateInput(value: string): void {
            this.temporaryInput = value;
            if (new Checker().updateInput(this.linkedInput, this.temporaryInput)) {
                this.linkedInput.value = this.temporaryInput;
                this.function();
            }
        }
    }
</script>